// Commons Styles
:root {
  // Typography
  // --font-family: system-ui, -apple-system, "Segoe UI", "Roboto", "Ubuntu", "Cantarell", "Noto Sans",
  //   sans-serif, "Apple Color Emoji", "Segoe UI Emoji", "Segoe UI Symbol", "Noto Color Emoji";
  --font-family: "Catamaran";
  --font-family-mono: "Menlo", "Consolas", "Roboto Mono", "Ubuntu Monospace", "Noto Mono",
    "Oxygen Mono", "Liberation Mono", monospace, "Apple Color Emoji", "Segoe UI Emoji",
    "Segoe UI Symbol", "Noto Color Emoji";
  --line-height: 1.5;
  --font-weight: 400;
  --font-size: 16px;

  // Responsive typography
  @if $enable-responsive-typography {
    @if map-get($breakpoints, "sm") {
      @media (min-width: map-get($breakpoints, "sm")) {
        --font-size: 17px;
      }
    }

    @if map-get($breakpoints, "md") {
      @media (min-width: map-get($breakpoints, "md")) {
        --font-size: 18px;
      }
    }

    @if map-get($breakpoints, "lg") {
      @media (min-width: map-get($breakpoints, "lg")) {
        --font-size: 19px;
      }
    }

    @if map-get($breakpoints, "xl") {
      @media (min-width: map-get($breakpoints, "xl")) {
        --font-size: 20px;
      }
    }
  }

  // Borders
  --border-radius: 0.25rem;
  --border-width: 1px;
  --outline-width: 3px;

  // Spacings
  --spacing: 1rem;

  // Spacings
  --gap: 0.25rem;

  // Spacings for typography elements
  --typography-spacing-vertical: 1.5rem;

  // Spacings for body > header, body > main, body > footer, section, article
  --block-spacing-vertical: calc(var(--spacing) * 1.5);
  --block-spacing-horizontal: var(--spacing);

  @if ($enable-classes and $enable-grid) {
    --grid-spacing-vertical: calc(var(--spacing) * 0.666);
    --grid-spacing-horizontal: var(--spacing);
  }

  // Spacings for form elements and button
  --form-element-spacing-vertical: 0.15rem;
  --form-element-spacing-horizontal: 0.65rem;

  // Spacings for nav component
  --nav-element-spacing-vertical: 1rem;
  --nav-element-spacing-horizontal: 0.5rem;
  --nav-link-spacing-vertical: 0.5rem;
  --nav-link-spacing-horizontal: 0.5rem;

  // Font weight for form labels & fieldsets legend
  --form-label-font-weight: var(--font-weight);

  // Transitions
  --transition-duration: 0.2s;
  --transition: var(--transition-duration) ease-in-out;

  // Wrapped text content
  --page-width: 800px;
}

// Responsives spacings
@if $enable-responsive-spacings {
  // Sectionning
  body > header,
  body > main,
  body > footer,
  section {
    @if map-get($breakpoints, "sm") {
      @media (min-width: map-get($breakpoints, "sm")) {
        --block-spacing-vertical: calc(var(--spacing) * 2.5);
      }
    }

    @if map-get($breakpoints, "md") {
      @media (min-width: map-get($breakpoints, "md")) {
        --block-spacing-vertical: calc(var(--spacing) * 3);
      }
    }

    @if map-get($breakpoints, "lg") {
      @media (min-width: map-get($breakpoints, "lg")) {
        --block-spacing-vertical: calc(var(--spacing) * 3.5);
      }
    }

    @if map-get($breakpoints, "xl") {
      @media (min-width: map-get($breakpoints, "xl")) {
        --block-spacing-vertical: calc(var(--spacing) * 4);
      }
    }
  }

  // Card (<article>)
  article {
    @if map-get($breakpoints, "sm") {
      @media (min-width: map-get($breakpoints, "sm")) {
        --block-spacing-horizontal: calc(var(--spacing) * 1.25);
      }
    }

    @if map-get($breakpoints, "md") {
      @media (min-width: map-get($breakpoints, "md")) {
        --block-spacing-horizontal: calc(var(--spacing) * 1.5);
      }
    }

    @if map-get($breakpoints, "lg") {
      @media (min-width: map-get($breakpoints, "lg")) {
        --block-spacing-horizontal: calc(var(--spacing) * 1.75);
      }
    }

    @if map-get($breakpoints, "xl") {
      @media (min-width: map-get($breakpoints, "xl")) {
        --block-spacing-horizontal: calc(var(--spacing) * 2);
      }
    }

    &.small {
      --block-spacing-vertical: var(--spacing);
      @if map-get($breakpoints, "sm") {
        @media (min-width: map-get($breakpoints, "sm")) {
          --block-spacing-horizontal: calc(var(--spacing) * 0.75);
        }
      }

      @if map-get($breakpoints, "md") {
        @media (min-width: map-get($breakpoints, "md")) {
          --block-spacing-horizontal: calc(var(--spacing) * 0.85);
        }
      }

      @if map-get($breakpoints, "lg") {
        @media (min-width: map-get($breakpoints, "lg")) {
          --block-spacing-horizontal: calc(var(--spacing) * 1);
        }
      }

      @if map-get($breakpoints, "xl") {
        @media (min-width: map-get($breakpoints, "xl")) {
          --block-spacing-horizontal: calc(var(--spacing) * 1);
        }
      }
    }
  }

  // Modal
  dialog > article {
    --block-spacing-vertical: calc(var(--spacing) * 2);
    --block-spacing-horizontal: var(--spacing);

    @if map-get($breakpoints, "sm") {
      @media (min-width: map-get($breakpoints, "sm")) {
        --block-spacing-vertical: calc(var(--spacing) * 2.5);
        --block-spacing-horizontal: calc(var(--spacing) * 1.25);
      }
    }

    @if map-get($breakpoints, "md") {
      @media (min-width: map-get($breakpoints, "md")) {
        --block-spacing-vertical: calc(var(--spacing) * 3);
        --block-spacing-horizontal: calc(var(--spacing) * 1.5);
      }
    }
  }
}

// Link
a {
  --text-decoration: none;

  // Secondary & Contrast
  @if $enable-classes {
    &.secondary,
    &.contrast {
      --text-decoration: underline;
    }
  }
}

// Small
small {
  --font-size: 0.875em;
}

// Headings
h1,
h2,
h3,
h4,
h5,
h6 {
  --font-weight: 700;
}

h1 {
  --font-size: 2em;
  --typography-spacing-vertical: 3rem;
}

h2 {
  --font-size: 1.75em;
  --typography-spacing-vertical: 2.625rem;
}

h3 {
  --font-size: 1.5em;
  --typography-spacing-vertical: 2.25rem;
}

h4 {
  --font-size: 1.25em;
  --typography-spacing-vertical: 1.874rem;
}

h5 {
  --font-size: 1.125em;
  --typography-spacing-vertical: 1.6875rem;
}

// Forms elements
[type="checkbox"],
[type="radio"] {
  --border-width: 2px;
}

[type="checkbox"][role="switch"] {
  --border-width: 3px;
}

// Table
thead,
tfoot {
  th,
  td {
    --border-width: 3px;
  }
}

:not(thead):not(tfoot) > * > td {
  --font-size: 0.875em;
}

// Code
pre,
code,
kbd,
samp {
  --font-family: var(--font-family-mono);
}

kbd {
  --font-weight: bolder;
}
